/**
 * $B5M$aLdBj$r:n@.$9$k(B
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
#include <vector>
using namespace std;

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  size_t size=table.allBoard.size();
  vector<int> checkWinOrLose(size,0);
  Board board;
  for(size_t i=0;i<table.winOrLose.size();i++){
    if(table.winOrLose[i]==100) checkWinOrLose[i]=table.winOrLose[i];
    else if(table.winOrLose[i]<=-99) checkWinOrLose[i]=table.winOrLose[i];
    else if(table.winOrLose[i]>0)  checkWinOrLose[i]=1;
    else if(table.winOrLose[i]<0){
      board.init(table.allBoard[i]);
      board.revColor();
      if(board.canWin()) checkWinOrLose[i]= -2;
      else checkWinOrLose[i]= -1;
    }
  }
  vector<int> counts(101,0);
  for(int nmoves=1;;nmoves++){
    int changed=0;
    for(size_t i=0;i<table.winOrLose.size();i++){
      if(checkWinOrLose[i]==1){
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  if(checkWinOrLose[k]< -2){
	    checkWinOrLose[i]= -checkWinOrLose[k]-1;
	    counts[-checkWinOrLose[k]-1]++;
	    if(counts[-checkWinOrLose[k]-1]==1){
	      board.init(table.allBoard[i]);
	      std::cout << -checkWinOrLose[k]-1 << std::endl;
	      std::cout << board << std::endl;
	    }
	    changed++;
	    break;
	  }
	}
      }
      else if(checkWinOrLose[i]== -2){
	int minval=101;
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  minval=std::min(minval,checkWinOrLose[k]);
	}
	if(minval>1){
	  checkWinOrLose[i]= -minval+1;
	  changed++;
	}
      }
    }
    cerr << "nmoves=" << nmoves << ",changed=" << changed << endl;
    if(changed==0)break;
  }
  for(size_t i=0;i<101;i++)
    if(counts[i]>0)
      cerr << "i=" << i << ",counts=" << counts[i] << std::endl;
  return 0;
}
