/**
 * $B:GD9$N2r$r5a$a$k(B
 * $B<j?t(B49$BI,MW$J0J2<$N2r$r8+$D$1$k(B
 * . . . .
 *  - . .
 * + . . .
 *  + . .
 * . - . .
 *  . . +
 * - . . .
 * -> 
 * . . . .
 *  - . .
 * + . . .
 *  + . .
 * . . . .
 *  . . +
 * - . + -
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
using namespace std;

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  int minWin=60;
  for(size_t i=0;i<table.winOrLose.size();i++){
    if(table.winOrLose[i]>0 && table.winOrLose[i]<minWin){
      Board state,state1;
      state.init(table.allBoard[i]);
      vector<PackedBoard> nexts;
      state.nextStates(nexts);
      int count=0;
      for(size_t j=0;j<table.allNexts[i].size();j++){
	int k=table.allNexts[i][j];
	if(table.winOrLose[k]<0) {
	  state1.init(nexts[j]);
	  state1.revColor();
	  count++;
	}
      }
      if(count==1){
	minWin=table.winOrLose[i];
	cout << "---------" << endl;
	cout << minWin << ":" << endl;
	cout << state << endl;
	cout << state1 << endl;
      }
    }
  }
  return 0;
}
